package recitation4;
import bus.uigen.OEFrame;
import bus.uigen.ObjectEditor;

public class Driver {
	private static final int NUM_MOVES = 100;
	private static final int SLEEP_TIME = 10;
	private static final int INIT_LINE_X = 10;
	private static final int INIT_LINE_Y = 50;
	private static final int INIT_LINE_WIDTH = 30;
	private static final int INIT_LINE_HEIGHT = 30;
	private static final int INIT_SHAPE_X = 50;
	private static final int INIT_SHAPE_Y = 50;
	private static final int INIT_SHAPE_HEIGHT = 30;
	private static final int INIT_SHAPE_WIDTH = 30;
	private static final int EDITOR_X = 800;
	private static final int EDITOR_Y = 300;
	
	public static void main(String[] args) {
		IShapePair pair = new ShapePair(new ALine(INIT_LINE_X, INIT_LINE_Y, INIT_LINE_WIDTH, INIT_LINE_HEIGHT),
				new AShape(INIT_SHAPE_X, INIT_SHAPE_Y, INIT_SHAPE_WIDTH, INIT_SHAPE_HEIGHT));
		OEFrame editor = ObjectEditor.edit(pair);
//		editor.showTreePanel();   /** Try uncommenting this **/
//		editor.hideMainPanel();   /** Try uncommenting this (when using Bean Pattern in AShape) **/
		editor.setSize(EDITOR_X, EDITOR_Y);
		/*demo, motion of object*/
		for(int i = 0;i < NUM_MOVES; i++){
			sleep(SLEEP_TIME);/* the unit is millisecond*/
			moveShapes(pair,1);
			editor.refresh();
		}
		resetPair(pair.getFirst(), editor);
		resetPair(pair.getSecond(), editor);
		/*demo ends*/
		
	}
	
	public static void resetPair(IShape shape, OEFrame editor) {
		((IResettable)shape).reset();
		editor.refresh();
	}
	/*move an object along the x axis*/
	public static void moveShape(IShape lineInstance, int xDist){
		lineInstance.setX(xDist + lineInstance.getX());
	}
	/* move an array of objects along the x axis
	 *  by calling the moveShape method individually
	 */
	public static void moveShapes(IShapePair pair, int xDist){
		moveShape(pair.getFirst(), xDist);
		moveShape(pair.getSecond(), xDist);
	}
	
	/*enable program can be hung up for a while*/
    public static void sleep(long interval) {
        try {
            Thread.sleep(interval);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
